/**
 * 待回访，已回访,综合查询
 * */
var detailOrderNum = ''; //获取工单详情的工单编号
$(document).ready(function() {
	//初始化时间
	laydate.render({
		elem: '#sc_time',
		range: '~',
		theme: '#1ab394',
		calendar: true
	});
	//获取工单来源
	helper.getDropList.getlistDropByDic($('#sc_source'), 'GDLY');
	//获取工单类型
	helper.getDropList.getlistDropByDic($('#sc_order_type'), 'GDLX');
	//获取呼叫结果
	helper.getDropList.getlistDropByDic($('#sc_callResult'), 'HJJG');
	
	initTable();
	$("#sc_btns").click(function() {
		initTable();
	});

	//详情
	$(".ckxq ul li").click(function() {
		$(this).addClass("Active").siblings().removeClass("Active");
		var tabindex = $(this).index();
		$(".gdxq").hide();
		$(".gdxq").eq(tabindex).show();
		if(tabindex === 0) {
			getWorkOrderDetails();
		} else if(tabindex > 0 && tabindex < 4) {
			getItemList(tabindex);
		} else if(tabindex === 4) {
			initTableLogs();
		}
	});
	$(".Closed").click(function() {
		$(".ckxq").addClass("Hidens");
	});

});

//工单管理内的列表
function initTable() {
	var orderMenu = top.$("iframe:visible")[0].src.split('/visit/')[1];
	//console.log(orderMenu);
	//是否回访（0待回访，1已回访，null回访查询）
	var ltype = '';
	switch(orderMenu) {
		case "awaitVist.html": //待回访
			ltype = '0';
			break;
		case "haveVisit.html": //已回访
			ltype = '1';
			break;
		case "resultVisit.html": //综合查询
			ltype = $('#sc_returnVisit').val();
			break;
		default:
			break;
	}
	//先销毁表格
	$('#workorderlist').bootstrapTable('destroy');
	//初始化表格,动态从服务器加载数据
	$("#workorderlist").bootstrapTable({
		method: "get", //使用get请求到服务器获取数据
		url: huayi.config.callcenter_url + "QuestionAnswer/GetWordOrderQuestionVisitList", //获取数据的Servlet地址
		contentType: 'application/x-www-form-urlencoded',
		striped: true, //表格显示条纹
		pagination: true, //启动分页
		pageSize: 5, //每页显示的记录数
		pageNumber: 1, //当前第几页
		pageList: [5, 20, 50, 100], //记录数可选列表
		search: false, //是否启用查询
		showColumns: false, //显示下拉框勾选要显示的列
		showRefresh: false, //显示刷新按钮
		sidePagination: "server", //表示服务端请求
		//设置为undefined可以获取pageNumber，pageSize，searchText，sortName，sortOrder
		//设置为limit可以获取limit, offset, search, sort, order
		queryParamsType: "undefined",
		queryParams: function queryParams(params) { //设置查询参数
			var param = {
				page: params.pageNumber,
				pagesize: params.pageSize,
				isreturnbak: ltype, //	是	string	是否回访（0待回访，1已回访，null回访查询）
				id: $('#sc_key').val(), //	是	string	工单编号
				type: $('#sc_source').val(), //	是	string	工单来源(字典)
				gdlx: $('#sc_order_type').val(), //	是	string	工单类型(字典)
				callresultid: $('#sc_callResult').val(), //	呼叫结果
				starttime: $('#sc_time').val() && $('#sc_time').val().split(' ~ ')[0], //否	string	工单起止时间
				endtime: $('#sc_time').val() && $('#sc_time').val().split(' ~ ')[1], //否	string	工单起止时间
				token: $.cookie("token")
			};
			return param;
		},
		onLoadSuccess: function() { //加载成功时执行
			//layer.msg("加载成功");
		},
		onLoadError: function() { //加载失败时执行
			//layer.msg("加载数据失败", { time: 1500, icon: 2 });
		}
	});
}

//格式化工单编号
function formatterOrderId(val, row) {
	return '<div class="imgs" ><a class="xg" onclick= btn_detail("' + val + '") >' + val + '</a></div>';
}

//格式化客户电话（待回访）
function formatterTel(val, row) {
	return '<div class="imgs" ><a class="xg" onclick= btn_visit("' + row.WorkOrderID + '") >' + val + '</a></div>';
}

//格式化客户电话（已回访）
function formatterHaveTel(val, row) {
	return '<div class="imgs" ><a class="xg" onclick= btn_haveVisit("' + row.WorkOrderID + '") >' + val + '</a></div>';
}
//格式化 工单状态
function formatterState(val) {
	var stateStr = '-';
	var stateClass = "";
	switch(val) { //工单状态0待指派，1待处理，2已处理
		case 0:
			stateStr = '待指派';
			stateClass = 'audit_wait';
			break;
		case 1:
			stateStr = '待处理';
			stateClass = 'audit_revoke';
			break;
		case 2:
			stateStr = '已处理';
			stateClass = 'audit_done';
			break;
		default:
			break;
	}
	return '<div class="' + stateClass + '">' + stateStr + '</div>';
}

//格式化 工单有效性
function formatterIsEffective(val) {
	var stateStr = '-';
	var stateClass = '';
	switch(val) { //是否有效工单项(0有效，1无效)
		case 0:
			stateStr = '有效';
			stateClass = 'audit_done';
			break;
		case 1:
			stateStr = '无效';
			stateClass = 'audit_revoke';
			break;
		default:
			break;
	}
	return '<div class="' + stateClass + '">' + stateStr + '</div>';
}

//格式化回访状态
function formatterIsReturnBak(val) {
	var stateStr = '';
	switch(val) { //0 待回访， 1 已回访
		case 0:
			stateStr = '待回访';
			stateClass = 'audit_wait';
			break;
		case 1:
			stateStr = '已回访';
			stateClass = 'audit_done';
			break;
		default:
			break;
	}
	return '<div class="' + stateClass + '">' + stateStr + '</div>';
}

//格式化 反馈内容
function formatterDetail(val) {
	if(val) {
		var strD = decodeURIComponent(val);
		strD = helper.filter.filterHTMLTag(strD);
		if(strD.length > 10) {
			strD = strD.substring(0, 10) + '...';
		}
		return strD;
	}

}

//格式化接收人
function formatterAuditUser(val) {
	if(val === "0") {
		return '-';
	} else {
		return val;
	}
}

//查看详情
function btn_detail(oid) {
	$(".ckxq").removeClass("Hidens");
	detailOrderNum = oid;
	$(".ckxq ul li").eq(0).trigger("click");
}

//回访
function btn_visit(oid) {
	layer.open({
		type: 2,
		title: '回访信息',
		maxmin: true, //开启最大化最小化按钮
		shade: 0,
		area: ['80%', '90%'],
		content: '../commonTpl/LookMessage.html?oid=' + oid
	});
}

//回访结果
function btn_haveVisit(oid) {
	layer.open({
		type: 2,
		title: '回访结果信息',
		maxmin: true, //开启最大化最小化按钮
		shade: 0,
		area: ['80%', '90%'],
		content: '../commonTpl/LookMessages.html?oid=' + oid
	});
}
//获取工单详情
function getWorkOrderDetails() {
	$.getJSON(huayi.config.callcenter_url + 'WorkOrder/GetWorkOrder', {
		"orderid": detailOrderNum,
		"token": $.cookie("token")
	}, function(result) {
		if(result.state.toLowerCase() == "success") {

			if(result.data.data && result.data.data.length > 0) {
				var data = result.data.data[0];
				$("#xq_gdbh").text(data.WorkOrderID);
				$("#xq_gdlx").text(data.GDLXName); //工单类型
				$("#xq_cjsj").text(data.CreateTime); //创建时间
				$("#xq_gdzt").html(formatterState(data.State)); //工单状态
				$("#xq_khxm").text(data.Customer); //客户姓名
				$("#xq_khdh").text(data.CustomerTel); //客户电话

				$("#xq_iseffective").html(formatterIsEffective(data.IsEffective)); //工单有效性
				$("#xq_source").text(data.GDLYName); //工单来源
				$('#xq_regin').text(data.areaname); //区域名称		

				$('#xq_pro').text(data.proname); //项目名称
				$('#xq_floor').text(data.buildingname); //期号名称
				$('#xq_buildingnum').text(data.BuildingNum);//	否	string	 楼号
				$('#xq_unitnum').text(data.UnitNum);//	否	string	单元
				$('#xq_room').text(data.Address); //房间号

				$('#xq_ownerrelations').text(data.OwnerrelationsName); //房主关系
				$('#xq_customerresponse').text(data.OustomerResponseName); //客户反应
				$("#xq_zxgh").text(data.CreateUserName1); //创建人
				if(data.TypeClass === 107) { //咨询
					$('#xq_complaint').hide();
				} else if(data.TypeClass === 108) { //投诉
					$('#xq_complaint').show();
					data.ComplaintDepartment = data.ComplaintDepartment === null ? '' : data.ComplaintDepartment;
					data.CustomerTypeName = data.CustomerTypeName === null ? '' : data.CustomerTypeName;
					$("#xq_fkdep").text(data.ComplaintDepartment + data.CustomerTypeName); //投诉类型？
					if(data.ResponDept != "-1") {
						data.ResponDept = data.ResponDept === 1 ? '是' : '否';
					} else {
						data.ResponDept = '保密';
					}
					$("#isquality").text(data.ResponDept); //是否过质保
					data.AuditUserNameRel = data.AuditUserNameRel === "" ? '——' : data.AuditUserNameRel;
					$("#xq_responseUser").text(data.AuditUserNameRel); //接收人
				}
				$("#xq_gdnr").html(decodeURIComponent(data.Detail)); //反馈内容
				if(data.IsEffective === 0) {
					$('.xq_notes').hide();
				} else {
					$('.xq_notes').show();
					$("#xq_note").text(data.Province); //无效原因
				}

			}
		}
	});
}

//获取 处理记录催办记录评论记录
function getItemList(type) {
	//先销毁表格
	var table = $("#itemTableList" + type);
	table.bootstrapTable('destroy');
	//初始化表格,动态从服务器加载数据
	table.bootstrapTable({
		method: "get", //使用get请求到服务器获取数据
		url: huayi.config.callcenter_url + "WorkOrder/GetItemList", //获取数据的Servlet地址
		contentType: 'application/x-www-form-urlencoded',
		striped: true, //表格显示条纹
		pagination: true, //启动分页
		pageSize: 10, //每页显示的记录数
		pageNumber: 1, //当前第几页
		pageList: [10, 20, 50, 100], //记录数可选列表
		search: false, //是否启用查询
		showColumns: false, //显示下拉框勾选要显示的列
		showRefresh: false, //显示刷新按钮
		sidePagination: "server", //表示服务端请求
		//设置为undefined可以获取pageNumber，pageSize，searchText，sortName，sortOrder
		//设置为limit可以获取limit, offset, search, sort, order
		queryParamsType: "undefined",
		queryParams: function queryParams(params) { //设置查询参数
			var param = {
				page: params.pageNumber,
				pagesize: params.pageSize,
				type: type,
				id: $('#xq_gdbh').text(),
				token: $.cookie("token")
			};
			return param;
		},
		onLoadSuccess: function() { //加载成功时执行
			//layer.msg("加载成功");
		},
		onLoadError: function() { //加载失败时执行
			//layer.msg("加载数据失败", { time: 1500, icon: 2 });
		}
	});
}

//获取修改记录
function initTableLogs() {
	//先销毁表格
	$('#itemTableList4').bootstrapTable('destroy');
	//初始化表格,动态从服务器加载数据
	$("#itemTableList4").bootstrapTable({
		method: "get", //使用get请求到服务器获取数据
		url: huayi.config.callcenter_url + "WorkOrderLogs/GetList", //获取数据的Servlet地址
		contentType: 'application/x-www-form-urlencoded',
		striped: true, //表格显示条纹
		pagination: true, //启动分页
		pageSize: 10, //每页显示的记录数
		pageNumber: 1, //当前第几页
		pageList: [10, 20, 50, 100], //记录数可选列表
		search: false, //是否启用查询
		showColumns: false, //显示下拉框勾选要显示的列
		showRefresh: false, //显示刷新按钮
		sidePagination: "server", //表示服务端请求
		//设置为undefined可以获取pageNumber，pageSize，searchText，sortName，sortOrder
		//设置为limit可以获取limit, offset, search, sort, order
		queryParamsType: "undefined",
		queryParams: function queryParams(params) { //设置查询参数
			var param = {
				page: params.pageNumber, //否	int	当前页
				pagesize: params.pageSize, //否	int	每页数
				orderid: detailOrderNum, //否	string	工单编号
				//				keyword: detailOrderNum, //否	string	模糊搜索（之前反馈内容，修改的反馈内容，工单编号）
				//starttime: $('#sc_time').val() && $('#sc_time').val().split(' ~ ')[0], //否	string	工单起止时间
				//endtime: $('#sc_time').val() && $('#sc_time').val().split(' ~ ')[1], //否	string	工单起止时间
				token: $.cookie("token"),
			};
			return param;
		},
		onLoadSuccess: function() { //加载成功时执行
			//layer.msg("加载成功");
			authorizeOperateButton();
		},
		onLoadError: function() { //加载失败时执行
			//layer.msg("加载数据失败", { time: 1500, icon: 2 });
		}
	});
}

//格式化处理详情
function formatterDealDetail(val, row) {
	var str = '';
	if(!row.IsLast && !row.DealTime && !row.SureUserName && !row.ToDeptName){
		str = str + row.CreateUserName + " 创建了工单。" + "<br>";
	}
	if(row.IsLast) {
		str = str + row.CreateUserName + " 完结工单。" + "<br>";
	}
	if(row.DealTime) {
		str = str + row.CreateUserName + " 处理工单：" + "<br>";
		str = str + row.Detail + "<br>";
	}
	if(row.SureUserName) {
		str = str + row.SureUserName + " 接单。" + "<br>";
	}
	
	if(row.ToDeptName) {
		if(row.State != 6){
			str = str + row.CreateUserName + " 指派工单给 " + row.ToDeptName + "：";
			if(row.ToUserName) {
				str = str + row.ToUserName;
			}
		}
		if(row.State === 6){
			str = str +  row.ToDeptName + "：" + row.ToUserName  + " 将工单退回给 " + row.CreateUserName;
		}
		str = str + "<br>";
	}
	
	if(row.IsStart) {
		str = str + row.CreateUserName + " 重新开启工单。" + "<br>";
	}
	return str;
}




//格式化操作 （修改记录）
function formatterOprateLogs(val, row) {
	return '<ul class="tool_downs">' +
		'<li><a href="javascript:;" class="aBtn" authorize="yes" id="HY_deleteLogs_' + row.Id + '" onclick="btn_deleteLogs(' + row.Id + ')" title="删除">删除</a></li>' +
		'</ul>';
}

//修改记录删除
function btn_deleteLogs(oid) {
	layer.confirm('确定删除当前记录？', {
		btn: ['是', '否'] //按钮
	}, function(index) {
		/*执行删除*/
		$.ajax({
			type: "post",
			url: huayi.config.callcenter_url + "WorkOrderLogs/Delete",
			dataType: 'json',
			async: true,
			data: {
				ids: oid,
				token: $.cookie("token")
			},
			success: function(data) {
				layer.msg("删除成功！");
				$('#itemTableList4').bootstrapTable('refresh');
				layer.close(index);
			}
		});
	});
}

//导出
function dcexcel(obj) {
	var orderMenu = top.$("iframe:visible")[0].src.split('/visit/')[1];
	//console.log(orderMenu);
	//是否回访（0待回访，1已回访，null回访查询）
	var ltype = '';
	switch(orderMenu) {
		case "awaitVist.html": //待回访
			ltype = '0';
			break;
		case "haveVisit.html": //已回访
			ltype = '1';
			break;
		case "resultVisit.html": //综合查询
			ltype = '';
			break;
		default:
			break;
	}
	var url = huayi.config.callcenter_url + "QuestionAnswer/ExportVisitList?token=" + $.cookie("token");
	url += "&isreturnbak=" + ltype;
	url += "&id=" + $("#sc_key").val();
	url += "&type=" + $("#sc_source").val();
	url += "&starttime=" + ($('#sc_time').val() && $('#sc_time').val().split(' ~ ')[0]);
	url += "&endtime=" + ($('#sc_time').val() && $('#sc_time').val().split(' ~ ')[1]);
	obj.href = url;
}

//获取 userType 判断按钮权限
function authorizeOperateButton() {
	var userType = $.cookie("userType");
	//userType = "-1";//测试数据
	$('.tool_downs').find('[authorize=yes]').hide();
	$('#workorderlist').find('.workOprate').hide();
	switch(userType) {
		case "-1":
			$('.tool_downs').find('[authorize=yes]').show();
			$('#workorderlist').find('.workOprate').show();
			break;
		case "1": //接待部 （创建、处理、修改工单）
			break;
		case "2": //2--案场经理  --项目负责人 (查看、接单、处理、催办)
			break;
		case "3": //3--销售部总经理 --物业部总经理 --工程总经理 --设计总经理 (可查看分配至各案场经理的所有单子，并跟踪查阅进度)
			break;
		case "4": //4--区域客服  （查看、分配（工程人员、设计人员）、催办）
			break;
		default:
			break;
	}

}